c$Id:$
      subroutine uasble(s,p,ld,ns,afl,bfl,b)

c      * * F E A P * * A Finite Element Analysis Program

c....  Copyright (c) 1984-2001: Regents of the University of California
c                               All rights reserved

c-----[--.----+----.----+----.-----------------------------------------]
c     Purpose: User to assemble current matrix/vector for SuperLU

c     Inputs:
c       s(ns,ns)  - element matrix
c       p(ns)     - element vector
c       ld(ns)    - local/global active equation numbers
c       ns        - size of arrays
c       afl       - Assemble s(ns,ns) into global storage
c       bfl       - Assemble p(ns)    into global storage

c     Outputs:
c       b(*)      - Assembled RHS vector
c-----[--.----+----.----+----.-----------------------------------------]
      implicit  none

      include  'compas.h'
      include  'eqsym.h'
      include  'part0.h'
      include  'rdat1.h'

      include  'pointer.h'
      include  'comblk.h'

      logical   afl,bfl
      integer   i, j, ns
      integer   ld(ns)
      real*8    s(ns,ns),p(ns),b(*)

c     Assemble matrix

      if(afl) then

        call cassem(hr(np(npart)),hr(np(npart)),hr(np(npart)),s,
     &              mr(np(226)),mr(np(225)),mr(np(48)),ld,ns,afl,
     &             .true.,.true.,.true.)
      endif

c     Assemble vector and compute norms

      if(bfl) then
        do i = 1,ns
          if(ld(i).gt.0) b(ld(i)) = b(ld(i)) + p(i)
        end do ! i
        if(compre) then
          do i = 1,ns
            rnorm1 = rnorm1 + abs(p(i))
          end do ! i
          rnormn = rnormn + dble(ns)
        endif
      endif

      end
