c$Id: uiters.f,v 1.1 2001/08/01 17:16:19 rlt Exp $
      subroutine uiters(nnu,isw)

c      * * F E A P * * A Finite Element Analysis Program

c....  Copyright (c) 1984-2001: Regents of the University of California
c                               All rights reserved

c-----[--.----+----.----+----.-----------------------------------------]
c     Purpose:  User utility for forming sparse arrays for SuperLU

c     Inputs:
c       isw      Switch parameter (must be a negative number)

c     Outputs:
c       nnu      Length of allocated array: Integer parameter
c                Location arrays: Returned in pointers
c                   np(225) for # terms/column
c                   np(226) for location of terms
c-----[--.----+----.----+----.-----------------------------------------]
      implicit   none

      include   'allotd.h'
      include   'cdata.h'
      include   'comblk.h'
      include   'compac.h'
      include   'pointer.h'
      include   'psize.h'
      include   'sdata.h'

      logical    setvar,palloc
      integer    isw,kp,nnu

c     Compute sparse storage for matrix

      if(isw.eq.-1) then

        setvar = palloc(151,'USER1', max(numnp*ndf,neq), 1)
        call elcnt(numel,nen,nen1,mr(np(31)),mr(np(33)),mr(np(151)),1)

c       Check for contact elements

        if(numcels.gt.0 .and. np(168).gt.0) then
          call elcnt(numcels,ncen,ncen1,mr(np(31)),mr(np(168)),
     &               mr(np(151)),-1)
        endif
        call sumcnt(mr(np(151)),numnp*ndf,kp)

        setvar = palloc(152,'USER2', kp, 1)
        call pelcon(numel,nen,nen1,mr(np(33)),mr(np(31)),mr(np(151)),
     &              mr(np(152)),kp,1)
        if(numcels.gt.0 .and. np(168).gt.0) then
          call pelcon(numcels,ncen,ncen1,mr(np(168)),mr(np(31)),
     &                mr(np(151)),mr(np(152)),kp,-1)
        endif

c       Assign storage type

        ubycol = .true.       ! Store by columns
        udiag  = .false.      ! Diagonal in separate part of array
        uall   = .true.       ! Assemble all of column
        setvar =  palloc(225,'USOL1', ndf*numnp, 1)
        if(np(226).ne.0) then
          setvar = palloc(226,'USOL2',0, 1)
        endif
        setvar = palloc(226,'USOL2',  1, 1)
        call compro(numnp,nen,nen1,ndf,mr(np(33)),mr(np(31)),
     &              mr(np(151)),mr(np(152)),mr(np(226)),mr(np(225)),
     &              kp,maxm-mmax,ubycol,udiag,uall)
        setvar = palloc(226,'USOL2', kp, 1)
        nnu    = kp

c       Delete temporary arrays

        setvar = palloc(152,'USER2', 0, 1)
        setvar = palloc(151,'USER1', 0, 1)

      else
        write(*,*) '  *ERROR* OPTION NOT IMPLEMENTED FOR ISW =',isw
      endif

      end
