c$Id:$
      subroutine umacr1(lct,ctl,prt)

c      * * F E A P * * A Finite Element Analysis Program

c....  Copyright (c) 1984-2001: Regents of the University of California
c                               All rights reserved

c-----[--.----+----.----+----.-----------------------------------------]
c      Purpose:  User interface for SuperLU solver

c      Inputs:
c         lct       - Command character parameters
c         ctl(3)    - Command numerical parameters
c                     ctl(1) = Ordering for SuperLU
c                              1 : For Natural ordering
c                              2 : For MMD for A' * A 
c                              3 : For MMD for A' + A (default)   
c                              4 : For Approximate MMD
c                     N.B. passed to solver as nint(ctl(1)) - 1
c         prt       - Flag, output if true

c      Outputs:
c         solver    - Indicates user solver or system solver
c                     .true.  = system solver
c                     .false. = user solver
c-----[--.----+----.----+----.-----------------------------------------]
      implicit  none

      include  'fdata.h'
      include  'iofile.h'
      include  'part0.h'
      include  'setups.h'
      include  'umac1.h'

      logical   pcomp,prt, setvar,palloc
      character lct*15,tname*5
      real*8    ctl(3)

      save

c     Install command SPLU (for SuPerLU)

      if(pcomp(uct,'mac1',4)) then

        uct = 'SPLU'
        write(iow,2000) uct
        write(  *,2000) uct
        uct = 'splu'

c     Set solver type

      else

        if(pcomp(lct,'off',3)) then
          solver = .true.
          setvar = palloc(225,'USOL1', 0,1)
          setvar = palloc(226,'USOL2', 0,1)
          write(tname,'(4hTANG,i1)') npart
          setvar = palloc(npart,tname, 0,2)
        else
          solver = .false.
          if(nint(ctl(1)).eq.0) then
            processor = 3
          else
            processor = max(1,min(nint(ctl(1)),4))
          endif
          if(pfr) then
            write(iow,2001) processor
            if(ior.lt.0) then
              write(*,2001) processor
            endif
          endif
          processor = processor - 1
        endif

      endif

2000  format(/' --> User solver ',a,' installed'/)
2001  format(/'  SuperLU Unsymmetric Sparse Solver'/
     *       /'      1: Use Natural ordering'/
     &        '      2: Use MMD for A^t * A '/
     &        '      3: Use MMD for A^t + A '/
     &        '      4: Use Approximate MMD , Option =',i2)

      end
